## ipxe 1.21.1+git20250224.12ea8c40+dfsg

=== debian/changelog ===
ipxe (1.21.1+git20250224.12ea8c40+dfsg-2) unstable; urgency=medium

  * Enable dh_auto_test and add removed B-D back again.
  * d/control: remove useless B-D alternatives.

 -- Shengqi Chen <harry@debian.org>  Thu, 27 Feb 2025 00:41:10 +0800

ipxe (1.21.1+git20250224.12ea8c40+dfsg-1) unstable; urgency=medium

  * d/control: update orders of alternative B-Ds to fix FTBFS on buildd
  * New upstream version 1.21.1+git20250224.12ea8c40+dfsg
  * d/{control,rules}: temporarily disable dh_auto_test and remove B-D
    to break dependency loop (closes: #1098923)

 -- Shengqi Chen <harry@debian.org>  Wed, 26 Feb 2025 13:36:10 +0800

ipxe (1.21.1+git20250207.bd90abf4+dfsg-1) unstable; urgency=medium

  [ Miao Wang ]
  * Enable ipxe self-tests on all architectures.
  * d/rules: prevent rebuilding the whold tree when building different
    images.
  * d/tests: reset the console after running the tests.

  [ Shengqi Chen ]
  * Upload to unstable.
  * d/control: bump std-ver to 4.7.1 (no changes required).

 -- Shengqi Chen <harry@debian.org>  Wed, 26 Feb 2025 00:21:39 +0800

ipxe (1.21.1+git20250207.bd90abf4+dfsg-1~exp3) experimental; urgency=medium

  * d/rules: When compiling any packages for i386, use i686-linux-gnu-
    tool chain.

 -- Miao Wang <shankerwangmiao@gmail.com>  Mon, 17 Feb 2025 17:22:00 +0800

ipxe (1.21.1+git20250207.bd90abf4+dfsg-1~exp2) experimental; urgency=medium

  * d/control: Adjust build dependencies for riscv64 and loong64
  * d/p/fix-lkrn-long-version.patch: Add patch to fix boot failure when
    the version string is too long.

 -- Miao Wang <shankerwangmiao@gmail.com>  Sat, 15 Feb 2025 13:22:00 +0800

ipxe (1.21.1+git20250207.bd90abf4+dfsg-1~exp1) experimental; urgency=medium

  [ Shengqi Chen ]
  * New upstream version 1.21.1+git20250207.bd90abf4+dfsg
  * d/patches: remove applied patches

  [ Miao Wang ]
  * Enable building and autopkgtest on riscv64 and loong64
  * Adjust expected sizes in d/util/check-rom-sizes
  * Enable more commands: vlan, reboot, poweroff, ping
  * d/copyright: update according to new upstream sources

 -- Shengqi Chen <harry@debian.org>  Fri, 14 Feb 2025 21:07:05 +0800

=== debian/control ===
Source: ipxe
Section: admin
Priority: optional
Maintainer: Miao Wang <shankerwangmiao@gmail.com>
Uploaders: Shengqi Chen <harry@debian.org>
Build-Depends:
    debhelper-compat (= 13),
    dh-exec,
    liblzma-dev:native,
    xxd,
    zlib1g-dev:native,
    expect <!nocheck>,
Build-Depends-Indep:
    dosfstools:native,
    gcc-x86-64-linux-gnu,
    gcc-aarch64-linux-gnu,
    gcc-loongarch64-linux-gnu,
    gcc-riscv64-linux-gnu,
    isolinux,
    mtools,
    syslinux-common,
    xorriso,
    seabios <!nocheck>,
    ovmf <!nocheck>,
    qemu-efi-aarch64 <!nocheck>,
    qemu-efi-riscv64 <!nocheck>,
    qemu-efi-loongarch64 <!nocheck>,
    qemu-system-x86 <!nocheck>,
    qemu-system-arm <!nocheck>,
    qemu-system-riscv <!nocheck>,
    qemu-system-misc <!nocheck>,
Build-Depends-Arch:
    seabios [i386 amd64] <!nocheck>,
    ovmf [amd64] <!nocheck>,
    qemu-system-x86 [i386 amd64] <!nocheck>,
    qemu-efi-aarch64 [arm64] <!nocheck>,
    qemu-system-arm [arm64] <!nocheck>,
    qemu-efi-riscv64 [riscv64] <!nocheck>,
    qemu-system-riscv [riscv64] <!nocheck>,
    qemu-efi-loongarch64 [loong64] <!nocheck>,
    qemu-system-misc [loong64],
    dosfstools:native <!nocheck>,
    mtools <!nocheck>,
Standards-Version: 4.7.1
Rules-Requires-Root: no
Homepage: https://ipxe.org/
Vcs-Git: https://salsa.debian.org/debian/ipxe.git
Vcs-Browser: https://salsa.debian.org/debian/ipxe

Package: ipxe
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Recommends: grub-ipxe
Description: PXE boot firmware
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for all supported network cards in one
 binary and several bootable formats.

Package: ipxe-qemu
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: PXE boot firmware - ROM images for qemu
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for the qemu emulated network cards
 as boot ROMs.


Package: grub-ipxe
Architecture: i386 amd64 arm64 riscv64 loong64
Suggests: grub2-common
Depends: ${misc:Depends}
Breaks: ipxe (<< 1.21.1+git20220113.fbbdc3926+dfsg-3)
Replaces: ipxe (<< 1.21.1+git20220113.fbbdc3926+dfsg-3)
Description: Network booting using iPXE
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 This package contains bootable iPXE images and adds a menu entry to grub2 for
 network booting using iPXE.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

%:
	dh $@

# qemu EFI roms shall be built with CONFIG=qemu
# This makes it apply src/config/*, src/config/qemu/*, src/config/local/*,
# src/config/local/qemu/* in this order.
src/bin-%.rom src/bin-%.efirom: export CONFIG=qemu

# Export CROSS prefix for building.
# This controls the architecture-specific build tools to be used.
src/bin-i386-pcbios%: export CROSS=x86_64-linux-gnu-
src/bin-i386-pcbios%: export DEB_HOST_ARCH=amd64

src/bin-x86_64-efi%: export CROSS=x86_64-linux-gnu-
src/bin-x86_64-efi%: export DEB_HOST_ARCH=amd64

src/bin-arm64-efi%: export CROSS=aarch64-linux-gnu-
src/bin-arm64-efi%: export DEB_HOST_ARCH=arm64

src/bin-riscv64-efi%: export CROSS=riscv64-linux-gnu-
src/bin-riscv64-efi%: export DEB_HOST_ARCH=riscv64

src/bin-loong64-efi%: export CROSS=loongarch64-linux-gnu-
src/bin-loong64-efi%: export DEB_HOST_ARCH=loong64

# For i386, use the i686-linux-gnu- toolchain when x86_64-linux-gnu- is not
# available. This is the case when building any package for i386 host.
ifeq ($(DEB_HOST_ARCH),i386)
ifneq ($(shell dpkg-query --show --showformat '$${db:Status-Status}' gcc-x86-64-linux-gnu),installed)
src/bin-i386-pcbios%: export CROSS=i686-linux-gnu-
src/bin-i386-pcbios%: export DEB_HOST_ARCH=i386
endif
endif

# used in (patched) src/Makefile
export HOST_CFLAGS = $(shell dpkg-buildflags --get CFLAGS_FOR_BUILD) $(shell dpkg-buildflags --get LDFLAGS_FOR_BUILD) -D__BLHC_IGNORE_HOSTCC

# 1. forcibly use cross tools and ignore DEB_HOST_ARCH
# 2. also setting CXX and PKG_CONFIG even if they are not used
#    to avoid confusing names in build logs
# 3. XFLAGS from env cannot be reused since DEB_HOST_ARCH is reset
# 4. save the files that are modified by the build, restore them when
#    next build of the same <arch>-<platform> is triggered, to prevent
#    unnecessary rebuilds
define run-dh_auto_build =
if [ -e "$(dir $@)/config.tar" ]; then \
	tar -C src -xf "$(dir $@)/config.tar"; \
fi
@if [ "$$DEB_HOST_ARCH" != "$(DEB_BUILD_ARCH)" ]; then \
	echo "blhc: ignore-line-regexp: .*$$CROSS.*"; \
fi
CC="$${CROSS}gcc" \
CXX="$${CROSS}g++" \
PKG_CONFIG="$${CROSS}pkg-config" \
CFLAGS="$$(dpkg-buildflags --get CFLAGS)" \
CPPFLAGS="$$(dpkg-buildflags --get CPPFLAGS)" \
LDFLAGS="$$(dpkg-buildflags --get LDFLAGS)" \
dh_auto_build --sourcedirectory=src -- \
	V=1 NO_WERROR=1 VERSION="$(DEB_VERSION)" $(subst src/,,$@)
tar -C src -cf "$(dir $@)/config.tar" config/local config/named.h include/compiler.h include/ipxe/profile.h include/assert.h
endef

src/bin-i386-pcbios%:
	$(run-dh_auto_build)

src/bin-x86_64-efi%:
	$(run-dh_auto_build)

src/bin-arm64-efi%:
	$(run-dh_auto_build)

src/bin-riscv64-efi%:
	$(run-dh_auto_build)

src/bin-loong64-efi%:
	$(run-dh_auto_build)

# efi roms are >256k since Bionic due to https + natural growth
# stay at 256k-512k after disabling https in efi via padding
define run-catrom =
@mkdir -p $(dir $@)
src/util/catrom.pl $^ > $@
src/util/padimg.pl --blksize=524288 --byte=0xff --verbose $@
endef

x86-only-roms = eepro100 ns8390 pcnet32

$(addprefix src/bin-combined/,$(addsuffix .efirom,$(x86-only-roms))): src/bin-combined/%.efirom: src/bin-i386-pcbios-rom/%.rom src/bin-x86_64-efi-rom/%.efirom
	$(run-catrom)

src/bin-combined/%.efirom: src/bin-i386-pcbios-rom/%.rom src/bin-x86_64-efi-rom/%.efirom src/bin-arm64-efi-rom/%.efirom src/bin-riscv64-efi-rom/%.efirom src/bin-loong64-efi-rom/%.efirom
	$(run-catrom)

src/bin-combined/%.iso: src/bin-i386-pcbios/%.lkrn src/bin-x86_64-efi/%.efi src/bin-arm64-efi/%.efi src/bin-riscv64-efi/%.efi src/bin-loong64-efi/%.efi
	@mkdir -p $(dir $@)
	debian/util/geniso $@ $^

define get_targets
$(shell \
  for pkg in $$(dh_listpackages $(1)); do \
    if [ -e "debian/$$pkg.$(2)" ]; then \
	  ( \
		if [ -x "debian/$$pkg.$(2)" ]; then \
		  dh-exec --with= "debian/$$pkg.$(2)"; \
		else \
		  cat "debian/$$pkg.$(2)"; \
		fi \
	  ) | grep -hoE 'src/bin\S+'; \
	fi; \
  done \
)
endef

# ================
# dh targets below
# ================

execute_before_dh_auto_build:
	@echo "blhc: ignore-line-regexp: .*__BLHC_IGNORE_HOSTCC.*"

override_dh_auto_build-indep: $(call get_targets,-i,install)
override_dh_auto_build-arch: $(call get_targets,-a,install)

execute_after_dh_install-indep:
	debian/util/check-rom-sizes

override_dh_auto_clean:
	dh_auto_clean --sourcedirectory=src -- veryclean
	rm -fr src/bin-*
	find src/config/local -type f -name '*.h' -size 0 -delete

ifeq (,$(filter nocheck, $(DEB_BUILD_OPTIONS)))

test_roms-indep = $(call get_targets,-i,testroms)
test_roms-arch = $(call get_targets,-a,testroms)

override_dh_auto_build-indep: $(test_roms-indep)
override_dh_auto_build-arch: $(test_roms-arch)

debian/self_tests/%: %
	./debian/tests/ipxe-tests $<
	mkdir -p $(dir $@) && touch $@

override_dh_auto_test-indep: $(addprefix debian/self_tests/,$(test_roms-indep))
override_dh_auto_test-arch: $(addprefix debian/self_tests/,$(test_roms-arch))

override_dh_auto_clean: clean_self_tests
clean_self_tests:
	rm -rf debian/self_tests

endif

=== debian/tests/control ===
Test-Command: ./debian/tests/ipxe-iso i386 cd
Depends: ipxe, expect, xxd, qemu-system-x86, seabios,
Features: test-name=iso-i386-cd

Test-Command: ./debian/tests/ipxe-iso i386 hd
Depends: ipxe, expect, xxd, qemu-system-x86, seabios,
Features: test-name=iso-i386-hd

Test-Command: ./debian/tests/ipxe-iso x86_64 cd
Depends: ipxe, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=iso-x86_64-cd

Test-Command: ./debian/tests/ipxe-iso x86_64 hd
Depends: ipxe, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=iso-x86_64-hd

Test-Command: ./debian/tests/ipxe-iso arm64 cd
Depends: ipxe, expect, xxd, qemu-system-arm, qemu-efi-aarch64,
Features: test-name=iso-arm64-cd

Test-Command: ./debian/tests/ipxe-iso arm64 hd
Depends: ipxe, expect, xxd, qemu-system-arm, qemu-efi-aarch64,
Features: test-name=iso-arm64-hd

Test-Command: ./debian/tests/ipxe-iso riscv64 cd
Depends: ipxe, expect, xxd, qemu-system-riscv, qemu-efi-riscv64,
Features: test-name=iso-riscv64-cd

Test-Command: ./debian/tests/ipxe-iso riscv64 hd
Depends: ipxe, expect, xxd, qemu-system-riscv, qemu-efi-riscv64,
Features: test-name=iso-riscv64-hd

Test-Command: ./debian/tests/ipxe-iso loong64 cd
Depends: ipxe, expect, xxd, qemu-system-loongarch | qemu-system-misc, qemu-efi-loongarch64,
Features: test-name=iso-loong64-cd

Test-Command: ./debian/tests/ipxe-iso loong64 hd
Depends: ipxe, expect, xxd, qemu-system-loongarch | qemu-system-misc, qemu-efi-loongarch64,
Features: test-name=iso-loong64-hd

Test-Command: ./debian/tests/ipxe-rom i386 e1000
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-e1000

Test-Command: ./debian/tests/ipxe-rom i386 e1000e
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-e1000e

Test-Command: ./debian/tests/ipxe-rom i386 rtl8139
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-rtl8139

Test-Command: ./debian/tests/ipxe-rom i386 virtio
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-virtio

Test-Command: ./debian/tests/ipxe-rom i386 vmxnet3
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-vmxnet3

Test-Command: ./debian/tests/ipxe-rom i386 eepro100
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-eepro100

Test-Command: ./debian/tests/ipxe-rom i386 ne2k_pci
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-ne2k_pci

Test-Command: ./debian/tests/ipxe-rom i386 pcnet
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
Features: test-name=rom-i386-pcnet

Test-Command: ./debian/tests/ipxe-rom x86_64 e1000
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=rom-x86_64-e1000

Test-Command: ./debian/tests/ipxe-rom x86_64 e1000e
Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
Features: test-name=rom-x86_64-e1000e

Test-Command: ./debian/tests/ipxe-rom x86_64 rtl8139

## ipxe 1.21.1+git20250317.42a29d56+dfsg

=== debian/changelog ===
ipxe (1.21.1+git20250317.42a29d56+dfsg-1) unstable; urgency=medium

  [ Miao Wang ]
  * d/control: add <!nocheck> back for qemu-system-misc
  * d/p/reduce_efirom_size.patch: remove unnecessary objects
  * d/p/fix-lkrn-long-version.patch: use upstream patch
  * d/tests: add pxe boot tests
  * d/rules: output size information during combining ROMs
  * efirom: remove non-x86 roms and remain within 256k (closes: #1095073)
  * d/rules: fix build failure on i386

  [ Shengqi Chen ]
  * New upstream version 1.21.1+git20250317.42a29d56+dfsg
  * d/control: bump std-ver to 4.7.2 (no changes required)
  * d/patches: remove applied patch and refresh

 -- Shengqi Chen <harry@debian.org>  Tue, 18 Mar 2025 17:03:54 +0800

=== debian/control ===
--- 
+++ 
@@ -38,10 +38,10 @@
     qemu-efi-riscv64 [riscv64] <!nocheck>,
     qemu-system-riscv [riscv64] <!nocheck>,
     qemu-efi-loongarch64 [loong64] <!nocheck>,
-    qemu-system-misc [loong64],
+    qemu-system-misc [loong64] <!nocheck>,
     dosfstools:native <!nocheck>,
     mtools <!nocheck>,
-Standards-Version: 4.7.1
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://ipxe.org/
 Vcs-Git: https://salsa.debian.org/debian/ipxe.git

=== debian/tests/control ===
--- 
+++ 
@@ -39,43 +39,35 @@
 Features: test-name=iso-loong64-hd
 
 Test-Command: ./debian/tests/ipxe-rom i386 e1000
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
+Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios, debian-installer-13-netboot-amd64,
 Features: test-name=rom-i386-e1000
 
 Test-Command: ./debian/tests/ipxe-rom i386 e1000e
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
+Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios, debian-installer-13-netboot-amd64,
 Features: test-name=rom-i386-e1000e
 
 Test-Command: ./debian/tests/ipxe-rom i386 rtl8139
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
+Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios, debian-installer-13-netboot-amd64,
 Features: test-name=rom-i386-rtl8139
 
 Test-Command: ./debian/tests/ipxe-rom i386 virtio
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
+Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios, debian-installer-13-netboot-amd64,
 Features: test-name=rom-i386-virtio
 
 Test-Command: ./debian/tests/ipxe-rom i386 vmxnet3
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
+Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios, debian-installer-13-netboot-amd64,
 Features: test-name=rom-i386-vmxnet3
 
 Test-Command: ./debian/tests/ipxe-rom i386 eepro100
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
+Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios, debian-installer-13-netboot-amd64,
 Features: test-name=rom-i386-eepro100
 
 Test-Command: ./debian/tests/ipxe-rom i386 ne2k_pci
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
+Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios, debian-installer-13-netboot-amd64,
 Features: test-name=rom-i386-ne2k_pci
 
 Test-Command: ./debian/tests/ipxe-rom i386 pcnet
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios,
+Depends: ipxe-qemu, expect, xxd, qemu-system-x86, seabios, debian-installer-13-netboot-amd64,
 Features: test-name=rom-i386-pcnet
 
 Test-Command: ./debian/tests/ipxe-rom x86_64 e1000
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
-Features: test-name=rom-x86_64-e1000
-
-Test-Command: ./debian/tests/ipxe-rom x86_64 e1000e
-Depends: ipxe-qemu, expect, xxd, qemu-system-x86, ovmf,
-Features: test-name=rom-x86_64-e1000e
-
-Test-Command: ./debian/tests/ipxe-rom x86_64 rtl8139

## ipxe 1.21.1+git20250401.7e64e9b6+dfsg

=== debian/changelog ===
ipxe (1.21.1+git20250401.7e64e9b6+dfsg-2) unstable; urgency=medium

  * Fix FTBFS on gcc-15 (Closes: #1096851).
  * Fix autopkgtest error on i386 on some architectures.

 -- Miao Wang <shankerwangmiao@gmail.com>  Tue, 15 Apr 2025 23:59:45 +0800

ipxe (1.21.1+git20250401.7e64e9b6+dfsg-1) unstable; urgency=medium

  * New upstream version 1.21.1+git20250401.7e64e9b6+dfsg.
  * d/patches: refresh existing patches.

 -- Shengqi Chen <harry@debian.org>  Sat, 12 Apr 2025 21:49:03 +0800

ipxe (1.21.1+git20250317.42a29d56+dfsg-2) unstable; urgency=medium

  [ Miao Wang ]
  * Fix the removal of 64bit emulation on 32bit arches since qemu 10.
    (Closes: #1101412)
  * d/NEWS: add an entry to record the removal of iPXE stack from UEFI bootroms.
    (Closes: #1101493)

  [ Shengqi Chen ]
  * d/patches: remove useless patch and update metadata.

 -- Miao Wang <shankerwangmiao@gmail.com>  Wed, 09 Apr 2025 21:48:11 +0800

## ipxe 1.21.1+git20250501.dad20602+dfsg

=== src/Makefile ===
###############################################################################
#
# Initialise various variables
#

CLEANUP		:=
CFLAGS		:=
ASFLAGS		:=
LDFLAGS		:=
HOST_CFLAGS	:=
MAKEDEPS	:= Makefile
CROSS_COMPILE	?= $(CROSS)
SYMBOL_PREFIX	:=

###############################################################################
#
# Locations of tools
#
HOST_CC		:= gcc
RM		:= rm -f
TOUCH		:= touch
MKDIR		:= mkdir
CP		:= cp
ECHO		:= echo
PRINTF		:= printf
PERL		:= perl
PYTHON		:= python
TRUE		:= true
CC		= $(CROSS_COMPILE)gcc
CPP		= $(CC) -E
AS		= $(CROSS_COMPILE)as
LD		= $(CROSS_COMPILE)ld
SIZE		= $(CROSS_COMPILE)size
AR		= $(CROSS_COMPILE)ar
RANLIB		= $(CROSS_COMPILE)ranlib
OBJCOPY		= $(CROSS_COMPILE)objcopy
NM		= $(CROSS_COMPILE)nm
OBJDUMP		= $(CROSS_COMPILE)objdump
OPENSSL		:= openssl
CSPLIT		:= csplit
PARSEROM	:= ./util/parserom.pl
FIXROM		:= ./util/fixrom.pl
SYMCHECK	:= ./util/symcheck.pl
SORTOBJDUMP	:= ./util/sortobjdump.pl
PADIMG		:= ./util/padimg.pl
LICENCE		:= ./util/licence.pl
NRV2B		:= ./util/nrv2b
ZBIN		:= ./util/zbin
ELF2EFI32	:= ./util/elf2efi32
ELF2EFI64	:= ./util/elf2efi64
EFIROM		:= ./util/efirom
EFIFATBIN	:= ./util/efifatbin
EINFO		:= ./util/einfo
GENKEYMAP	:= ./util/genkeymap.py
DOXYGEN		:= doxygen
LCAB		:= lcab
QEMUIMG		:= qemu-img

###############################################################################
#
# SRCDIRS lists all directories containing source files.
#
SRCDIRS		:=
SRCDIRS		+= libgcc
SRCDIRS		+= core
SRCDIRS		+= net net/tcp net/udp net/infiniband
SRCDIRS		+= image
SRCDIRS		+= drivers/bus
SRCDIRS		+= drivers/net
SRCDIRS		+= drivers/net/e1000
SRCDIRS		+= drivers/net/e1000e
SRCDIRS		+= drivers/net/igb
SRCDIRS		+= drivers/net/igbvf
SRCDIRS		+= drivers/net/phantom
SRCDIRS		+= drivers/net/vxge
SRCDIRS		+= drivers/net/efi
SRCDIRS		+= drivers/net/tg3
SRCDIRS		+= drivers/net/bnxt
SRCDIRS		+= drivers/net/sfc
SRCDIRS		+= drivers/net/marvell
SRCDIRS		+= drivers/block
SRCDIRS		+= drivers/nvs
SRCDIRS		+= drivers/bitbash
SRCDIRS		+= drivers/infiniband
SRCDIRS		+= drivers/infiniband/mlx_utils_flexboot/src
SRCDIRS		+= drivers/infiniband/mlx_utils/src/public
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_reg_access
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_nvconfig
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_vmac
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_blink_leds
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_link_speed
SRCDIRS		+= drivers/infiniband/mlx_utils/mlx_lib/mlx_mtu
SRCDIRS		+= drivers/infiniband/mlx_nodnic/src
SRCDIRS		+= drivers/usb
SRCDIRS		+= interface/pxe interface/efi interface/smbios
SRCDIRS		+= interface/bofm
SRCDIRS		+= interface/xen
SRCDIRS		+= interface/hyperv
SRCDIRS		+= tests
SRCDIRS		+= crypto crypto/mishmash
SRCDIRS		+= hci hci/commands hci/tui
SRCDIRS		+= hci/mucurses hci/mucurses/widgets
SRCDIRS		+= hci/keymap
SRCDIRS		+= usr
SRCDIRS		+= config

# These directories contain code that is not eligible for UEFI Secure
# Boot signing.
#
SRCDIRS_INSEC	+= net/oncrpc
SRCDIRS_INSEC	+= net/80211
SRCDIRS_INSEC	+= drivers/net/rtl818x
SRCDIRS_INSEC	+= drivers/net/ath
SRCDIRS_INSEC	+= drivers/net/ath/ath5k
SRCDIRS_INSEC	+= drivers/net/ath/ath9k

# NON_AUTO_SRCS lists files that are excluded from the normal
# automatic build system.
#
NON_AUTO_SRCS	:=
NON_AUTO_SRCS	+= core/version.c
NON_AUTO_SRCS	+= drivers/net/prism2.c

# INCDIRS lists the include path
#
INCDIRS		:=
INCDIRS		+= include .

###############################################################################
#
# Default build target: build the most common targets and print out a
# helpfully suggestive message
#
ALL		:= bin/blib.a bin/ipxe.dsk bin/ipxe.lkrn bin/ipxe.iso \
		   bin/ipxe.usb bin/ipxe.pxe bin/undionly.kpxe bin/rtl8139.rom \
		   bin/8086100e.mrom bin/80861209.rom bin/10500940.rom \
		   bin/10222000.rom bin/10ec8139.rom bin/1af41000.rom \
		   bin/8086100f.mrom bin/808610d3.mrom bin/15ad07b0.rom

all : $(ALL)
	@$(ECHO) '==========================================================='
	@$(ECHO)
	@$(ECHO) 'To create a bootable floppy, type'
	@$(ECHO) '    cat bin/ipxe.dsk > /dev/fd0'
	@$(ECHO) 'where /dev/fd0 is your floppy drive.  This will erase any'
	@$(ECHO) 'data already on the disk.'
	@$(ECHO)
	@$(ECHO) 'To create a bootable USB key, type'
	@$(ECHO) '    cat bin/ipxe.usb > /dev/sdX'
	@$(ECHO) 'where /dev/sdX is your USB key, and is *not* a real hard'
	@$(ECHO) 'disk on your system.  This will erase any data already on'
	@$(ECHO) 'the USB key.'
	@$(ECHO)
	@$(ECHO) 'To create a bootable CD-ROM, burn the ISO image '
	@$(ECHO) 'bin/ipxe.iso to a blank CD-ROM.'
	@$(ECHO)
	@$(ECHO) 'These images contain drivers for all supported cards.  You'
	@$(ECHO) 'can build more customised images, and ROM images, using'
	@$(ECHO) '    make bin/<rom-name>.<output-format>'
	@$(ECHO)
	@$(ECHO) '==========================================================='

###############################################################################
#
# Comprehensive build target: build a selection of cross-platform
# targets to expose potential build errors that show up only on
# certain platforms
#
everything :
	$(Q)$(MAKE) --no-print-directory $(ALL) \
		bin/3c509.rom bin/intel.rom bin/intel.mrom \
		bin-x86_64-pcbios/8086100e.mrom bin-x86_64-pcbios/intel.rom \
		bin-x86_64-pcbios/ipxe.usb bin-x86_64-pcbios/ipxe.pxe \
		bin-x86_64-pcbios/undionly.kpxe \
		bin-i386-efi/ipxe.efi bin-i386-efi/ipxe.efidrv \
		bin-i386-efi/ipxe.efirom \
		bin-x86_64-efi/ipxe.efi bin-x86_64-efi/ipxe.efidrv \
		bin-x86_64-efi/ipxe.efirom \
		bin-i386-linux/tap.linux bin-x86_64-linux/tap.linux \
		bin-i386-linux/tests.linux bin-x86_64-linux/tests.linux

###############################################################################
#
# VMware build target: all ROMs used with VMware
#
vmware : bin/8086100f.mrom bin/808610d3.mrom bin/10222000.rom bin/15ad07b0.rom
	@$(ECHO) '==========================================================='
	@$(ECHO) 
	@$(ECHO) 'Available ROMs:'
	@$(ECHO) '    bin/8086100f.mrom -- intel/e1000'
	@$(ECHO) '    bin/808610d3.mrom -- intel/e1000e'
	@$(ECHO) '    bin/10222000.rom  -- vlance/pcnet32'
	@$(ECHO) '    bin/15ad07b0.rom  -- vmxnet3'
	@$(ECHO) 
	@$(ECHO) 'For more information, see https://ipxe.org/howto/vmware'
	@$(ECHO)
	@$(ECHO) '==========================================================='

###############################################################################
#
# Build targets that do nothing but might be tried by users
#
configure :
	@$(ECHO) "No configuration needed."

install :
	@$(ECHO) "No installation required."

###############################################################################
#
# Version number calculations
#
ifneq ($(wildcard ../.git),)
VERSIONS := $(shell git describe --tags --always --long --abbrev=1 --match "v*")
VERSION_TUPLE	:= $(subst ., ,$(subst -, ,$(patsubst v%,%,$(VERSIONS))))
VERSION_MAJOR	:= $(word 1,$(VERSION_TUPLE))
VERSION_MINOR	:= $(word 2,$(VERSION_TUPLE))
VERSION_PATCH	:= $(word 3,$(VERSION_TUPLE))
ifeq ($(word 4,$(VERSION_TUPLE)),0)
EXTRAVERSION	:=
else
EXTRAVERSION	:= +
endif
GITVERSION	= $(word 5,$(VERSION_TUPLE))
else
VERSION_MAJOR	= 1
VERSION_MINOR	= 0
VERSION_PATCH	= 0
EXTRAVERSION	= +
endif
MM_VERSION	= $(VERSION_MAJOR).$(VERSION_MINOR)
VERSION		= $(MM_VERSION).$(VERSION_PATCH)$(EXTRAVERSION)
ifneq ($(GITVERSION),)
VERSION		+= ($(GITVERSION))
endif
version :
	@$(ECHO) "$(VERSION)"

###############################################################################
#
# Predefined build shortcuts (for e.g. bin/ipxe.iso)

# All drivers (excluding USB)
#
DRIVERS_ipxe	= $(DRIVERS_net) $(DRIVERS_infiniband) \
		  $(DRIVERS_xen) $(DRIVERS_hyperv)

# Raspberry Pi
#
DRIVERS_rpi	= smsc95xx lan78xx

###############################################################################
#
# Drag in the bulk of the build system
#

MAKEDEPS	+= Makefile.housekeeping
include Makefile.housekeeping

=== src/arch/i386/Makefile ===
# Force i386-only instructions
#
CFLAGS		+= -march=i386

# Code size reduction.
#
CFLAGS		+= -fomit-frame-pointer

# Code size reduction.
#
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -fstrength-reduce
endif

# Code size reduction.  gcc3 needs a different syntax to gcc2 if you
# want to avoid spurious warnings.
#
ifeq ($(CCTYPE),gcc)
GCC_VERSION	:= $(subst ., ,$(shell $(CC) -dumpversion))
GCC_MAJOR	:= $(firstword $(GCC_VERSION))
ifeq ($(GCC_MAJOR),2)
CFLAGS		+= -malign-jumps=1 -malign-loops=1 -malign-functions=1
else
CFLAGS		+= -falign-jumps=1 -falign-loops=1 -falign-functions=1
endif # gcc2
endif # gcc

# Code size reduction.  This is almost always a win.  The kernel uses
# it, too.
#
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -mpreferred-stack-boundary=2
endif

# Code size reduction.  Use regparm for all functions - C functions
# called from assembly (or vice versa) need __asmcall now
#
CFLAGS		+= -mregparm=3

# Code size reduction.  Use -mrtd (same __asmcall requirements as above)
ifeq ($(CCTYPE),gcc)
CFLAGS		+= -mrtd
endif

# Code size reduction.  This is the logical complement to -mregparm=3.
# It doesn't currently buy us anything, but if anything ever tries to
# return small structures, let's be prepared
#
CFLAGS		+= -freg-struct-return

# Force 32-bit code even on an x86-64 machine
#
CFLAGS		+= -m32
ASFLAGS		+= --32
ifeq ($(HOST_OS),FreeBSD)
LDFLAGS		+= -m elf_i386_fbsd
else ifeq ($(HOST_OS),OpenBSD)
LDFLAGS		+= -m elf_i386_obsd
else
LDFLAGS		+= -m elf_i386
endif

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
#
CFLAGS		+= -fshort-wchar

# We need to undefine the default macro "i386" when compiling .S
# files, otherwise ".arch i386" translates to ".arch 1"...
#
CFLAGS			+= -Ui386

# i386-specific directories containing source files
#
SRCDIRS		+= arch/i386/core
SRCDIRS		+= arch/i386/tests

# Include common x86 Makefile
#
MAKEDEPS	+= arch/x86/Makefile
include arch/x86/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/i386/Makefile.$(PLATFORM)
include arch/i386/Makefile.$(PLATFORM)

=== src/arch/loong64/Makefile ===
# Assembler section type character
#
ASM_TCHAR	:= @
ASM_TCHAR_OPS	:= @

# LoongArch64-specific flags
#
CFLAGS		+= -fstrength-reduce -fomit-frame-pointer
CFLAGS		+= -falign-jumps=1 -falign-loops=1 -falign-functions=1

# Check if -mno-explicit-relocs is valid
ifeq ($(CCTYPE),gcc)
MNER_TEST = $(CC) -mno-explicit-relocs -x c -c /dev/null -o /dev/null >/dev/null 2>&1
MNER_FLAGS := $(shell $(MNER_TEST) && $(ECHO) '-mno-explicit-relocs')
WORKAROUND_CFLAGS += $(MNER_FLAGS)
endif

# EFI requires -fshort-wchar, and nothing else currently uses wchar_t
CFLAGS		+= -fshort-wchar

# Include LoongArch64-specific headers
INCDIRS		:= arch/$(ARCH)/include $(INCDIRS)

# LoongArch64-specific directories containing source files
SRCDIRS		+= arch/loong64/core
SRCDIRS		+= arch/loong64/interface/efi

# Include platform-specific Makefile
MAKEDEPS	+= arch/loong64/Makefile.$(PLATFORM)
include arch/loong64/Makefile.$(PLATFORM)

=== src/arch/riscv32/Makefile ===
# RISCV32-specific directories containing source files
#
SRCDIRS		+= arch/riscv32/core
SRCDIRS		+= arch/riscv32/libgcc

# RISCV32-specific flags
#
CFLAGS		+= -march=rv32gc -mabi=ilp32d
ASFLAGS		+= -march=rv32gc -mabi=ilp32d
LDFLAGS		+= -m elf32lriscv

# Include common RISCV Makefile
#
MAKEDEPS	+= arch/riscv/Makefile
include arch/riscv/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/riscv32/Makefile.$(PLATFORM)
include arch/riscv32/Makefile.$(PLATFORM)

=== src/arch/riscv64/Makefile ===
# RISCV64-specific directories containing source files
#
SRCDIRS		+= arch/riscv64/core

# RISCV64-specific flags
#
CFLAGS		+= -march=rv64gc -mabi=lp64d
ASFLAGS		+= -march=rv64gc -mabi=lp64d
LDFLAGS		+= -m elf64lriscv

# Include common RISCV Makefile
#
MAKEDEPS	+= arch/riscv/Makefile
include arch/riscv/Makefile

# Include platform-specific Makefile
#
MAKEDEPS	+= arch/riscv64/Makefile.$(PLATFORM)
include arch/riscv64/Makefile.$(PLATFORM)

=== debian/changelog ===
ipxe (1.21.1+git20250501.dad20602+dfsg-1) unstable; urgency=medium

  * New upstream version 1.21.1+git20250501.dad20602+dfsg.
  * d/patches: refresh existing patches.

 -- Shengqi Chen <harry@debian.org>  Fri, 02 May 2025 16:55:24 +0800

=== debian/control ===
--- 
+++ 
@@ -25,20 +25,22 @@
     qemu-efi-aarch64 <!nocheck>,
     qemu-efi-riscv64 <!nocheck>,
     qemu-efi-loongarch64 <!nocheck>,
-    qemu-system-x86 <!nocheck>,
-    qemu-system-arm <!nocheck>,
-    qemu-system-riscv <!nocheck>,
-    qemu-system-misc <!nocheck>,
+    qemu-system-i386 <!nocheck>,
+    qemu-system-amd64 <!nocheck>,
+    qemu-system-arm64 <!nocheck>,
+    qemu-system-riscv64 <!nocheck>,
+    qemu-system-loong64 <!nocheck>,
 Build-Depends-Arch:
     seabios [i386 amd64] <!nocheck>,
     ovmf [amd64] <!nocheck>,
-    qemu-system-x86 [i386 amd64] <!nocheck>,
+    qemu-system-i386 [i386] <!nocheck>,
+    qemu-system-amd64 [amd64] <!nocheck>,
     qemu-efi-aarch64 [arm64] <!nocheck>,
-    qemu-system-arm [arm64] <!nocheck>,
+    qemu-system-arm64 [arm64] <!nocheck>,
     qemu-efi-riscv64 [riscv64] <!nocheck>,
-    qemu-system-riscv [riscv64] <!nocheck>,
+    qemu-system-riscv64 [riscv64] <!nocheck>,
     qemu-efi-loongarch64 [loong64] <!nocheck>,
-    qemu-system-misc [loong64] <!nocheck>,
+    qemu-system-loong64 [loong64] <!nocheck>,
     dosfstools:native <!nocheck>,
     mtools <!nocheck>,
 Standards-Version: 4.7.2

=== debian/watch ===
version=4
opts=\
	mode=git,\
	gitmode=full,\
	pretty=1.21.1+git%cd.%h,\
	repacksuffix=+dfsg,\
	dversionmangle=s/\+dfsg\d*// \
https://github.com/ipxe/ipxe.git \
HEAD

## ipxe 1.21.1+git20250602.5b3ebf8b+dfsg

=== debian/changelog ===
ipxe (1.21.1+git20250602.5b3ebf8b+dfsg-1) unstable; urgency=medium

  * New upstream version 1.21.1+git20250602.5b3ebf8b+dfsg

 -- Shengqi Chen <harry@debian.org>  Wed, 04 Jun 2025 16:06:29 +0800

## ipxe 1.21.1+git-20210429.323af9ee

=== debian/changelog ===
ipxe (1.21.1+git-20210429.323af9ee-0ubuntu1) impish; urgency=medium

  * Bump code to 1.21.1+git-20210429.323af9ee
    - Drop d/p/handle-dhcp-nack.patch: Handle DHCP NAK and send a
      re-discover. (LP 1707999)
      [replaced by 1192edf "Handle DHCPNAK by returning to discovery state"]
    - Drop d/p/lp-1882671-efi-Raise-TPL-during-driver-entry-point.patch
      [upstream in 1.21.0]
    - Drop d/p/build-Be-explicit-about-fcommon-compiler-directive.patch
      [upstream in 1.21.0]
    - update d/p/0005-strip-802.1Q-VLAN-0-priority-tags.patch to match 1.21
    - d/rules: don't clean explicitly in between builds

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 29 Apr 2021 16:12:33 +0200

ipxe (1.0.0+git-20190125.36a4c85-5ubuntu4) hirsute; urgency=medium

  * d/u/geniso: fix rounding to unbreak iso creation

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 30 Mar 2021 10:09:06 +0200

ipxe (1.0.0+git-20190125.36a4c85-5ubuntu3) groovy; urgency=medium

  * d/p/build-Be-explicit-about-fcommon-compiler-directive.patch: fix
    FTBFS with gcc-10
  * d/util/geniso: fix FTBFS due to rounding issues

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 01 Oct 2020 10:14:14 +0200

ipxe (1.0.0+git-20190125.36a4c85-5ubuntu2) groovy; urgency=medium

  * d/p/lp-1882671-efi-Raise-TPL-during-driver-entry-point.patch: fix the
    formerly avoided efi TPL issues (LP: #1882671)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 16 Jul 2020 14:36:54 +0200

ipxe (1.0.0+git-20190125.36a4c85-5ubuntu1) groovy; urgency=medium

  * Merge with Debian unstable (LP: #1884758). Remaining changes:
    - Split grub integration from ipxe->grub-ipxe.
      - d/control: add package and adapt dependencies
      - d/[grub-]ipxe.install: move some files to grub-ipxe
      - rename d/ipxe.post* to d/grub-ipxe-post*
      [updated to match 1.0.0+git-20190125.36a4c85-5]
    - d/util/check-rom-sizes, d/rules: check sizes of generated roms to avoid
      accidentally breaking KVM live migration on updates/fixes.
      [updated for new and dropped rom file names]
    - debian/copyright: update copyright information to satisfy lintian
      dep5 checks (LP: 1747071)
    - Build ROMs for QEMU with CONFIG=qemu (LP: 1789319)
      [updated to match 1.0.0+git-20190125.36a4c85-5 and be more verbose]
    - debian/patches/handle-dhcp-nack.patch: Handle DHCP NAK and send a
      re-discover. (LP 1707999)
    - d/p/0005-strip-802.1Q-VLAN-0-priority-tags.patch: Strip 802.1Q VLAN 0
      priority tags; Fixes PXE when VLAN tag is 0. (LP: 1805920)
    - d/tree/ipxe/etc/grub.d/20_ipxe: Make grub-ipxe work under UEFI
      (LP: 1811496)
      - Use ipxe.efi under UEFI
      - Save default entry when iPXE is selected
    - d/tree/ipxe/etc/grub.d/20_ipxe: Identify ipxe grub menu entry in
      an easier way (LP: 1858374)
  * Dropped changes
    - new upstream release 20190109.133f4c4 [superseded by new upstream]
    - new upstream release 20180124.fbe8c52d [superseded by new upstream]
    - Revert to the former git snapshot 20150424.a25a16d
      [superseded by new upstream]
      - This brings back debian/patches/0002-Don-t-use-libiberty.patch as needed
        on the older source.
      - Adapt d/p/0001-rom-change-banner-timeout.diff.patch to former state to
        match old source.
      - drop d/p/util-elf2efi-GNU_SOURCE.patch as it was not needed on old
        source
    - Fix FTBFS with newer perl versions [upstream]
    - d/p/0004-fix_no-pie_option.patch: correct -no-pie option
      to build without pie
      [ still carried before ]
    - Install ne.rom as pxe-ne2k_isa.rom
      - d/ipxe-qemu.install: Install ne.rom as pxe-ne2k_isa.rom.
      - d/ipxe-qemu.links: compat link for ne.rom
      [ no more needed, was an old xen hvmloader bug ]
    - d/ipxe-qemu.links: Add compat links from /usr/share/qemu
      to /usr/lib/ipxe/qemu.
      [ no more needed, transition from trusty ]
    - add new rom for vmxnet3 (LP 1737211) [in Debian now]
    - Add e1000e firmware for qemu. (closes 884240) [in Debian now]
    - d/control: ipxe-qemu breaks qemu-system-x86 <2.11 [no more needed]
    - d/p/enable-https.patch: Enable HTTPS support.
      [resolved per rom type in d/rules now]
  * Added changes
    - d/rules: only enable https on non EFI roms. This lets EFI handle https
      itself and avoids breakage in TPL manipulations (LP: #1882671)
    - d/util/check-rom-sizes: fix if size does exactly match

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Tue, 23 Jun 2020 16:23:52 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/default.mk

export ISOLINUX_BIN=/usr/lib/syslinux/

VERSION := $(shell dpkg-parsechangelog | sed -ne 's,^Version: *\(.*\)$$,\1,p')

%:
	+dh $@

override_dh_auto_configure:
	cp debian/config/* src/config/local

# qemu EFI roms shall be built with CONFIG=qemu
# This will make it select src/config/qemu/* as config base
# and set -DCONFIG=qemu -DLOCAL_CONFIG=qemu
src/bin-i386-pcbios/%.rom src/bin-x86_64-efi/%.efirom: export CONFIG=qemu
# qemu EFI roms are built without HTTPS, EFI does that on its own (and better)
src/bin-x86_64-efi/%.efirom: export NOHTTPS=true

src/bin-i386-pcbios/% src/bin-x86_64-efi/%:
	# clean and reconfigure if either NOHTTPS or CONFIG=qemu switches
	if [ "config:$(CONFIG)nohttps:$(NOHTTPS)" != "$(shell cat debian/last-used-config 2>/dev/null)" ]; then \
	    if [ "$(NOHTTPS)" = "true" ]; then \
	        cp -v debian/config/* src/config/local; \
	    else \
	        echo "#define DOWNLOAD_PROTO_HTTPS" >> src/config/local/general.h; \
	    fi; \
	   echo -n "config:$(CONFIG)" > debian/last-used-config; \
	   echo -n "nohttps:$(NOHTTPS)" >> debian/last-used-config; \
	fi;
	dh_auto_build --sourcedirectory=src -- V=1 NO_WERROR=1 VERSION="$(VERSION)" $(subst src/,,$@)

src/bin-combined/%.efirom: src/bin-i386-pcbios/%.rom src/bin-x86_64-efi/%.efirom
	@[ -d $(dir $@) ] || mkdir $(dir $@)
	src/util/catrom.pl $^ > $@
	# efi roms are >256k since Bionic due to https + natural growth
	# stay at 256k-512k after disabling https in efi via padding
	src/util/padimg.pl --blksize=524288 --byte=0xff --verbose $@

src/bin-combined/%.iso: src/bin-i386-pcbios/%.lkrn src/bin-x86_64-efi/%.efi
	@[ -d $(dir $@) ] || mkdir $(dir $@)
	debian/util/geniso $@ $^

override_dh_auto_build: $(shell grep -hoE 'src/bin(-[^/]*)?/\S+' debian/*.install)

override_dh_install:
	dh_install
	debian/util/check-rom-sizes

override_dh_auto_clean:
	$(MAKE) -C src veryclean
	rm -f debian/last-used-config
	rm -fr src/bin*
	rm -fr src/config/local/*

.NOTPARALLEL:
.SECONDARY:

## ipxe 1.21.1+git-20220113.fbbdc3926

=== debian/changelog ===
ipxe (1.21.1+git-20220113.fbbdc3926-0ubuntu2) noble; urgency=medium

  * Fix FTBFS with new binutils.
    - d/p/0003-Inhibit-linker-warnings-about-an-implied-executable-.patch
    - d/p/0004-Fix-building-with-newer-binutils.patch

 -- Sergio Durigan Junior <sergio.durigan@canonical.com>  Tue, 16 Apr 2024 17:17:04 -0400

ipxe (1.21.1+git-20220113.fbbdc3926-0ubuntu1) jammy; urgency=medium

  * Bump code to 1.21.1+git-20220113.fbbdc3926
  * d/grub-ipxe.install, d/control, d/rules: Build ipxe-arm64.efi
    (LP: #1890230)

 -- Christian Ehrhardt <christian.ehrhardt@canonical.com>  Thu, 13 Jan 2022 14:53:40 +0100

=== debian/control ===
Source: ipxe
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Bastian Blank <waldi@debian.org>
Build-Depends:
 debhelper-compat (= 12),
 dpkg-source-gitarchive,
 dh-exec,
 xorriso, isolinux, syslinux-common, syslinux-utils, dosfstools, mtools,
 binutils-dev, liblzma-dev, zlib1g-dev,
 gcc-aarch64-linux-gnu,
Standards-Version: 3.9.6
Homepage: http://ipxe.org/
Vcs-Git: https://salsa.debian.org/waldi/ipxe.git
Vcs-Browser: https://salsa.debian.org/waldi/ipxe

Package: ipxe
Architecture: all
Multi-Arch: foreign
Depends: ipxe-qemu, grub-ipxe, ${misc:Depends}
Description: PXE boot firmware
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for all supported network cards in one
 binary and several bootable formats.

Package: ipxe-qemu
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: PXE boot firmware - ROM images for qemu
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 It is possible to use iPXE as a PXE ROM in the network card or to
 chainload it from other boot methods.
 .
 This package provides boot code for the qemu emulated network cards in
 as boot ROMs.

Package: grub-ipxe
Architecture: all
Suggests: grub-pc (>= 1.96)
Depends: ${misc:Depends}
Description: Network booting from GRUB using iPXE
 iPXE is network boot firmware.  It supports a variety of network cards,
 including some wireless cards, and variety of network protocols (traditional
 DHCP, BOOTP and TFTP and also HTTP, iSCSI, SAN via FCoE and Infiniband). It
 supports scripting.
 .
 This package adds a menu entry to grub2 for network booting using iPXE.
